import Vue from 'vue'
import Vuex from 'vuex'
Vue.use(Vuex)

let infoData = {};
try {
	infoData = uni.getStorageSync('infoData')
} catch (e) {
	//TODO handle the exception
}

// 需要永久存储，且下次启动需要取出的，在state中的变量名
let saveStateKeys = ['vuex_user', 'vuex_token', 'vuex_hasLogin'];
// 保存变量到本地存储中
const saveLifeData = function(key, value) {
	// 判断变量名是否在需要存储的数组中
	if (saveStateKeys.indexOf(key) != -1) {
		// 获取本地存储的infoData对象，将变量添加到对象中
		let tmp = uni.getStorageSync('infoData');
		// 第一次打开APP，不存在infoData变量，故放一个{}空对象
		tmp = tmp ? tmp : {};
		tmp[key] = value;
		// 执行这一步后，所有需要存储的变量，都挂载在本地的infoData对象中
		uni.setStorageSync('infoData', tmp);
	}
}
const store = new Vuex.Store({
	state: {
		vuex_hasLogin: infoData.vuex_hasLogin ? infoData.vuex_hasLogin : false,
		vuex_user: infoData.vuex_user ? infoData.vuex_user : {},
		vuex_token: infoData.vuex_token ? infoData.vuex_token : ''
	},
	mutations: {
		$uStore(state, payload) {
			// 判断是否多层级调用，state中为对象存在的情况，诸如user.info.score = 1
			let nameArr = payload.name.split('.');
			let saveKey = '';
			let len = nameArr.length;
			if (nameArr.length >= 2) {
				let obj = state[nameArr[0]];
				for (let i = 1; i < len - 1; i++) {
					obj = obj[nameArr[i]];
				}
				obj[nameArr[len - 1]] = payload.value;
				saveKey = nameArr[0];
			} else {
				// 单层级变量，在state就是一个普通变量的情况
				state[payload.name] = payload.value;
				saveKey = payload.name;
			}
			// 保存变量到本地
			saveLifeData(saveKey, state[saveKey])
		}
	}
})
export default store
